VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.1#0"; "COMDLG32.OCX"
Begin VB.Form frmMain 
   Appearance      =   0  'Flat
   Caption         =   "frmMain"
   ClientHeight    =   6180
   ClientLeft      =   210
   ClientTop       =   795
   ClientWidth     =   10515
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "main7.frx":0000
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   6180
   ScaleWidth      =   10515
   Begin MSComDlg.CommonDialog dlgFont 
      Left            =   240
      Top             =   1080
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   327680
   End
   Begin VB.PictureBox picRuler 
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      DragMode        =   1  'Automatic
      ForeColor       =   &H80000008&
      Height          =   735
      Left            =   5100
      MousePointer    =   9  'Size W E
      ScaleHeight     =   735
      ScaleWidth      =   75
      TabIndex        =   3
      Top             =   420
      Width           =   75
   End
   Begin VB.ListBox lstMatches 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   0
      Sorted          =   -1  'True
      TabIndex        =   1
      Top             =   420
      Width           =   4695
   End
   Begin VB.TextBox txtResult 
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   615
      Left            =   5520
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   2
      Text            =   "main7.frx":030A
      Top             =   60
      Width           =   2415
   End
   Begin VB.TextBox txtSearch 
      Height          =   285
      Left            =   1005
      TabIndex        =   0
      Text            =   "txtSearch"
      Top             =   60
      Width           =   1875
   End
   Begin VB.Label Label1 
      Caption         =   "Search for"
      Height          =   255
      Left            =   30
      TabIndex        =   4
      Top             =   90
      Width           =   915
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFilePrintList 
         Caption         =   "&Print Matched List"
         Shortcut        =   ^P
      End
      Begin VB.Menu mnuFilePrint 
         Caption         =   "Print &Description"
         Shortcut        =   {F4}
      End
      Begin VB.Menu mnuFilePrintFont 
         Caption         =   "Printer &Font..."
         Shortcut        =   ^F
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit..."
         Shortcut        =   {F3}
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpVersion 
         Caption         =   "&Version..."
      End
      Begin VB.Menu mnuHelpUsing 
         Caption         =   "&Using MQMCH..."
         Shortcut        =   {F1}
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' MQMCH "MQSeries Messages and Codes Helper" in Visual Basic 5.0
'
' main7.frm  "frmMain" Form and Code module
'
' Copyright IBM Global Services Australia 2002
'
' Version    Date         Name      Changes
'     2.1    01 Sep 1999  Glenn     Initial version, based on PCWIN31\MQMCH\MAIN7.FRM for VB 3.0
'                         Baddeley  <glenbadd@au1.ibm.com>
'     2.2    13 Sep 1999  GB        txtResult and lstMatches dont overlap
'     2.3    20 Aug 2001  GB        Support MQ 5.2
'     2.4    24 Aug 2001  GB        Use registry rather that ini
'     2.5.1  19 Oct 2001  GB        Use DI_VERSION,
'                                   Change Middleware Support to Middleware Services
'     2.6.1  25 Feb 2002  GB        Break long lines in mnuFilePrint,
'                                   Add printer attributes to registry
'     2.7.1  03 Mar 2002  GB        Improved line breaking in mnuFilePrint,
'                                   Add mnuFilePrintFont
'
Option Explicit

Private Sub Form_DragDrop(Source As Control, X As Single, Y As Single)

    picRuler.Left = txtResult.Left - picRuler.Width - PIXELX * 2
    
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)

'   ShowResult txtResult & "Form_KeyDown: KeyCode=" & KeyCod) & "Shift=" & Shift & vbCrLf

    If RunningIde And KeyCode = Asc("M") And Shift = vbCtrlMask + vbAltMask + vbShiftMask Then
        DidMake = True
        frmMake.Show vbModal
        LoadBinaryResource
        If MessMax > 0 Then txtSearch_Change
    End If

End Sub

Private Sub Form_KeyPress(KeyAscii As Integer)

    If KeyAscii = Asc(vbCr) Then
        txtSearch_Change
        KeyAscii = 0
    End If

End Sub

Private Sub Form_Load()

Dim hRegKey As Long, RetCode As Long, Ruler As Long, Setting As Long
Dim SearchText As String
Dim PrtFontSize As Single

    Caption = App.Title

    ' Get users preferences from registry
    hRegKey = RegcOpenWriteCreate(HKCU, APPKEY)
    
    DebugFlag = RegcQueryValueLong(hRegKey, "Debug", CLng(False))
    Ruler = RegcQueryValueLong(hRegKey, "Ruler", 0)
    SearchText = RegcQueryValueString(hRegKey, "LastSearch", "")
    RegcGetWindowSize hRegKey, "MainWindow", Me
    ' Printer font settings
    On Error Resume Next
    dlgFont.FontName = RegcQueryValueString(hRegKey, "PrinterFontName", "Arial")
    PrtFontSize = RegcQueryValueLong(hRegKey, "PrinterFontSize", 10)
    If PrtFontSize < 6 Or PrtFontSize > 72 Then PrtFontSize = 10
    dlgFont.FontSize = PrtFontSize
    dlgFont.FontBold = (RegcQueryValueLong(hRegKey, "PrinterFontBold", 0) <> 0)
    On Error GoTo 0
    
    RegcClose hRegKey
    
    ' Set the vertical ruler
    If Ruler = 0 Then
        picRuler.Left = lstMatches.Left + lstMatches.Width + PIXELX * 2
        txtResult.Left = picRuler.Left + picRuler.Width + PIXELX * 2
    Else
        picRuler.Left = Ruler
        lstMatches.Width = Ruler - lstMatches.Left - PIXELX * 2
        txtResult.Left = Ruler + picRuler.Width + PIXELX * 2
    End If
    picRuler.ZOrder 1

    LoadBinaryResource
    
    ' Set tab stops on match list
    Setting = 24
    RetCode = SendMessage(lstMatches.hwnd, LB_SETTABSTOPS, 1, Setting)
    If RetCode = 0 Then MsgBox "AT_Setting=" & Setting & vbCrLf & "SendMessage(ATList.hwnd, EM_SETTABSTOPS, 1, Setting)) failed", vbExclamation, Caption

    txtSearch.Text = SearchText  ' Forces txtSearch_Change event
    txtSearch.SelStart = 0
    txtSearch.SelLength = Len(txtSearch)

End Sub

Private Sub Form_Resize()

Dim Try As Single

    If Visible And WindowState <> vbMinimized Then
        Try = ScaleWidth - lstMatches.Left - txtResult.Left
        If Try > PIXELX * 30 Then txtResult.Width = Try
        Try = ScaleHeight - txtResult.Top - PIXELY * 2
        If Try > PIXELY * 30 Then txtResult.Height = Try
        Try = ScaleHeight - lstMatches.Top - PIXELY * 2
        If Try > PIXELY * 30 Then lstMatches.Height = Try
        picRuler.Height = lstMatches.Height
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

Dim hRegKey As Long

    ' Save users preferences to registry
    hRegKey = RegcOpenWrite(HKCU, APPKEY)
    If hRegKey Then
        RegcWriteValueLong hRegKey, "Debug", DebugFlag
        RegcWriteValueLong hRegKey, "Ruler", picRuler.Left
        RegcWriteValueString hRegKey, "LastSearch", txtSearch.Text
        RegcPutWindowSize hRegKey, "MainWindow", Me
        RegcWriteValueString hRegKey, "PrinterFontName", dlgFont.FontName
        RegcWriteValueLong hRegKey, "PrinterFontSize", dlgFont.FontSize
        RegcWriteValueLong hRegKey, "PrinterFontBold", CLng(dlgFont.FontBold)
        RegcClose hRegKey
    End If
    
    If DidMake Then Unload frmMake

End Sub

Private Sub LoadBinaryResource()

Dim MessIdx As Integer, ErrNum As Integer
Dim ResCacheLen As Long, ResExeLen As Long
Dim BegTime As Long
Dim Msg As String, IdKey As String, IdData As String
Dim ErrFile As String

    Screen.MousePointer = vbHourglass
    ErrFile = ""
    On Error GoTo LoadError
    
    If DebugFlag Then BegTime = GetTickCount()
    ShowResult "Initialising..."
    MessMax = 0
    NumericKeys = ""
    SymbolicKeys = ""
    Edition = ""
    
    ErrFile = ResExeFile
    ResExeLen = FileLen(ResExeFile)

    ErrFile = ResCacheFile
    On Error Resume Next
    ResCacheLen = FileLen(ResCacheFile)
    ErrNum = Err
    On Error GoTo LoadError
    If ErrNum <> 53 And ErrNum <> 0 Then Error ErrNum

    If ResExeLen <> ResCacheLen Then FileCopy ResExeFile, ResCacheFile

    BinResOpen ResCacheFile, 0
    If BinResError Then
        ShowResult BINRESERRPFX & "Can't open to read." & vbCrLf & "File=" & ResCacheFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus
        Screen.MousePointer = vbDefault
        Exit Sub
    End If

    GoSub DoLoad

    BinResClose
    If BinResError Then Msg = Msg & BINRESERRPFX & "Can't close." & vbCrLf & "File=" & ResExeFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus

LoadExit:
    
    If Len(Msg) Then
        ShowResult Msg
        Beep
        MessMax = 0
        NumericKeys = ""
        SymbolicKeys = ""
    End If
    Screen.MousePointer = vbDefault
    If DebugFlag Then MsgBox "LoadBinaryResource took " & GetTickCount() - BegTime & " ms", , "Debug"

Exit Sub

LoadError:

    Msg = Msg & "File: " & ErrFile & vbCrLf & "Runtime Error " & Err & ": " & Error

Resume LoadExit

DoLoad:

    Msg = ""
    
    IdKey = "KeyCnt"
    MessMax = Val(BinResGet(IdKey))
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't get key '" & IdKey & "'." & vbCrLf & "File=" & ResExeFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus
        Return
    End If

    IdKey = "NumericKeys"
    NumericKeys = BinResGet(IdKey)
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't get key '" & IdKey & "'." & vbCrLf & "File=" & ResExeFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus
        Return
    End If

    IdKey = "SymbolicKeys"
    SymbolicKeys = BinResGet(IdKey)
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't get key '" & IdKey & "'." & vbCrLf & "File=" & ResExeFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus
        Return
    End If

    IdKey = MTYPEDI & "." & DI_VERSION
    Edition = BinResGet(IdKey)
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't get key '" & IdKey & "'." & vbCrLf & "File=" & ResExeFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus
        Return
    End If

    ReDim Mess(1 To MessMax) As MessType

    ReDim MatchIdxList(1 To MessMax) As Integer
    
    For MessIdx = 1 To MessMax
        IdKey = CStr(MessIdx)
        Mess(MessIdx).MText = BinResGet(IdKey)
        If BinResError Then
            Msg = Msg & BINRESERRPFX & "Can't get key '" & IdKey & "'." & vbCrLf & "File=" & ResExeFile & vbCrLf & "Error=" & BinResError & " " & BinResStatus
            Return
        End If
        Mess(MessIdx).MType = MTYPENONE ' The data is parsed on demand in txtSearch_Change
    Next MessIdx

Return

End Sub

Private Sub lstMatches_Click()

Dim LIdx As Integer
Dim Rep As String

    LIdx = lstMatches.ListIndex
    If LIdx > 0 Then
        ReportMess CInt(lstMatches.ItemData(LIdx)), Rep, True
        ShowResult Rep
    End If

End Sub

Private Sub ParseMess(MessIdx As Integer)

Dim ChPos1 As Integer, ChPos2 As Integer, ChPos3 As Integer
Dim IdData As String

    IdData = Mess(MessIdx).MText
    ChPos1 = InStr(IdData, FLDSEP)
    Mess(MessIdx).MType = CInt(Left(IdData, ChPos1 - 1))
    ChPos2 = InStr(ChPos1 + 1, IdData, FLDSEP)
    Mess(MessIdx).MValue = CLng(Mid(IdData, ChPos1 + 1, ChPos2 - ChPos1 - 1))
    ChPos3 = InStr(ChPos2 + 1, IdData, FLDSEP)
    Mess(MessIdx).MSymConst = Mid(IdData, ChPos2 + 1, ChPos3 - ChPos2 - 1)
    Mess(MessIdx).MText = Mid(IdData, ChPos3 + 1)

End Sub

Private Sub ReportMess(MessIdx As Integer, ReportStr As String, StripEols As Integer)

Dim EolPos As Integer, EolPrev As Integer, EolMax As Integer
Dim MsgType As String, MsgText As String, MsgSeg As String

    If Mess(MessIdx).MType = MTYPENONE Then ParseMess MessIdx

    Select Case Mess(MessIdx).MType
        Case MTYPECC
            MsgType = "Completion Code "
        Case MTYPERC
            MsgType = "Reason Code "
        Case Else
            MsgType = "Unknown message type " & Mess(MessIdx).MType & " for message " & MessIdx & "!" & vbCrLf
    End Select

    MsgText = Mess(MessIdx).MText
    EolPrev = 1
    Do
        EolPos = InStr(EolPrev, MsgText, EOLMARK)
        If EolPos = 0 Then Exit Do
        If StripEols Then
            If Mid(MsgText, EolPos + 1, 1) = EOLMARK Then
                MsgText = Left(MsgText, EolPos - 1) & vbCrLf & vbCrLf & Mid(MsgText, EolPos + 2)
                EolPrev = EolPos + 4
            Else
                MsgSeg = RTrim(Left(MsgText, EolPos - 1))
                MsgText = MsgSeg & " " & LTrim(Mid(MsgText, EolPos + 1))
                EolPrev = Len(MsgSeg) + 2
            End If
        Else
            MsgText = Left(MsgText, EolPos - 1) & vbCrLf & Mid(MsgText, EolPos + 1)
            EolPrev = EolPos + 2
        End If
    Loop
    
    ReportStr = MsgType & vbTab & Mess(MessIdx).MValue & vbTab & "x'" & Hex(Mess(MessIdx).MValue) & "'" & vbCrLf & UCase(Mess(MessIdx).MSymConst) & vbCrLf & vbCrLf & MsgText & vbCrLf

End Sub

Private Sub ShowResult(ResultStr As String)

    txtResult.Text = ResultStr
    txtResult.Refresh

End Sub

Private Sub lstMatches_DragOver(Source As Control, X As Single, Y As Single, State As Integer)

Dim Try As Single

    Try = X - PIXELX * 2
    If Try > PIXELX * 30 Then lstMatches.Width = Try
    txtResult.Left = X + picRuler.Width + PIXELX * 2
    Try = ScaleWidth - txtResult.Left - lstMatches.Left
    If Try > PIXELX * 30 Then txtResult.Width = Try
 
End Sub

Private Sub mnuFileExit_Click()

    Unload Me
    
End Sub

Private Sub mnuFilePrint_Click()

Const MAXTXTWIDTH = 256     ' Limit on Printer.TextWidth() and reasonable max printed line length
Dim PrevPos As Integer, ChPos As Integer, SpPos As Integer
Dim RepText As String, RepLine As String, RepSeg As String
Dim PrtTxtWidth As Single

    MousePointer = vbHourglass
    On Error GoTo PrintError
    
    PrinterInit
    Printer.Print Caption & vbCrLf
    PrtTxtWidth = Printer.ScaleWidth
    
    ' Parse the result text into CRLF delimited lines
    RepText = txtResult.Text & vbCrLf
    PrevPos = 1
    Do
        ChPos = InStr(PrevPos, RepText, vbCrLf)
        If ChPos = 0 Then Exit Do
        RepLine = RTrim(Mid(RepText, PrevPos, ChPos - PrevPos))
        ' Process the line
        If Len(RepLine) = 0 Then
            Printer.Print   ' A blank line
        Else
            ' Split into printable lines
            RepLine = RepLine & " "
            SpPos = Len(RepLine)
            If SpPos > MAXTXTWIDTH Then SpPos = MAXTXTWIDTH
            ' Find a space before line length
            Do While SpPos > 0
                If Mid(RepLine, SpPos, 1) = " " Then
                    RepSeg = Left(RepLine, SpPos - 1)
                    If Printer.TextWidth(RepSeg) < PrtTxtWidth Then
                        Printer.Print RepSeg
                        RepLine = Mid(RepLine, SpPos + 1)
                        SpPos = Len(RepLine) + 1
                        If SpPos > MAXTXTWIDTH Then SpPos = MAXTXTWIDTH
                    End If
                End If
                SpPos = SpPos - 1
                If SpPos = 0 Then
                    If Len(RepLine) > 0 Then     ' A long sequence with no spaces
                        RepSeg = Left(RepLine, 80)
                        Printer.Print RepSeg
                        RepLine = Mid(RepLine, 81)
                        SpPos = Len(RepLine)
                        If SpPos > MAXTXTWIDTH Then SpPos = MAXTXTWIDTH
                    End If
                End If
            Loop
        End If
        ' Parse the next result text line
        PrevPos = ChPos + 2
    Loop
    
PrintExit:

    Printer.EndDoc
    MousePointer = vbDefault

Exit Sub

PrintError:

    MousePointer = vbDefault
    MsgBox "Printer error:" & vbCrLf & vbCrLf & "(" & Err & ") " & Error, vbExclamation, "File - Print Description"

Resume PrintExit

End Sub

Private Sub mnuFilePrintFont_Click()

Const Cap = "Printer Font"

    On Error GoTo FontError

    dlgFont.Flags = cdlCFPrinterFonts + cdlCFForceFontExist
    dlgFont.CancelError = True

    dlgFont.ShowFont
    
    If dlgFont.FontItalic Then MsgBox "The selection of italics has been ignored.", vbInformation, Cap

FontExit:

Exit Sub

FontError:

    If Err <> 32755 Then
         MsgBox "Unexpected error " & Err & ":" & vbCrLf & vbCrLf & Error, vbExclamation, Cap
    End If

Resume FontExit

End Sub

Private Sub mnuHelpUsing_Click()

Dim Msg As String

    Msg = "Help - Using MQMCH" & vbCrLf & vbCrLf
    Msg = Msg & "An immediate search will be conducted on any text " & vbCrLf
    Msg = Msg & "that you type into the search text box. The " & vbCrLf
    Msg = Msg & "search will look for matches on MQI Reason Codes " & vbCrLf
    Msg = Msg & "and Completion Codes in both decimal and " & vbCrLf
    Msg = Msg & "hexidecimal, as well matches on parts of " & vbCrLf
    Msg = Msg & "symbolic names." & vbCrLf & vbCrLf
    Msg = Msg & "If many matches have been found a list is " & vbCrLf
    Msg = Msg & "displayed and clicking on a list entry will " & vbCrLf
    Msg = Msg & "display the entire text for that entry." & vbCrLf & vbCrLf
    Msg = Msg & "Press Enter to go back to the list of matches. " & vbCrLf
    Msg = Msg & "Once a unique match has been made the entire text" & vbCrLf
    Msg = Msg & "of the entry will be displayed."
    ShowResult Msg
    txtSearch.SetFocus
    lstMatches.ListIndex = -1

End Sub

Private Sub mnuHelpVersion_Click()

Dim Msg As String, EolPrev As Integer, EolPos As Integer

    Msg = App.Title & vbCrLf
    Msg = Msg & "Version " & App.Major & "." & App.Minor & "." & App.Revision & ", " & App.Comments & vbCrLf & vbCrLf
    Msg = Msg & "Copyright " & App.LegalCopyright & vbCrLf
    Msg = Msg & "Enterprise Systems Services" & vbCrLf
    Msg = Msg & "Middleware Services" & vbCrLf
    Msg = Msg & "Australian Helpdesk phone (03) 9253 8076" & vbCrLf
    Msg = Msg & "email <glenbadd@au1.ibm.com>" & vbCrLf & vbCrLf
    Msg = Msg & "Registry key for user preferences: HKEY_CURRENT_USER\" & vbCrLf & APPKEY
    
    EolPrev = 1
    Do
        EolPos = InStr(EolPrev, Edition, EOLMARK)
        If EolPos = 0 Then Exit Do
        Edition = Left(Edition, EolPos - 1) & vbCrLf & Mid(Edition, EolPos + 1)
        EolPrev = EolPos + 2
    Loop
    
    ShowResult Msg & vbCrLf & String(48, "_") & vbCrLf & vbCrLf & Edition
    txtSearch.SetFocus
    lstMatches.ListIndex = -1

End Sub

Private Sub mnuFilePrintList_Click()

Dim MaxIdx As Integer, Idx As Integer

    MousePointer = vbHourglass
    On Error GoTo PrintListError
    
    PrinterInit
    Printer.Print Caption & vbCrLf
    
    MaxIdx = lstMatches.ListCount - 1
    If MaxIdx > 1 Then
        For Idx = 0 To MaxIdx
            Printer.Print lstMatches.List(Idx)
        Next Idx
        Printer.Print
    End If

PrintListExit:

    Printer.EndDoc
    MousePointer = vbDefault

Exit Sub

PrintListError:

    MousePointer = vbDefault
    MsgBox "Printer error:" & vbCrLf & vbCrLf & "(" & Err & ") " & Error, vbExclamation, "File - Print Match List"

Resume PrintListExit

End Sub

Private Sub txtResult_DragOver(Source As Control, X As Single, Y As Single, State As Integer)
    
Dim Try As Single

    lstMatches.Width = txtResult.Left + X + PIXELX * 2
    txtResult.Left = lstMatches.Width + picRuler.Width + PIXELX * 2
    Try = ScaleWidth - txtResult.Left - lstMatches.Left
    If Try > PIXELX * 30 Then txtResult.Width = Try

End Sub

Private Sub txtSearch_Change()

Dim PrevPos As Integer, ChPos As Integer, MessIdx As Integer, MatchCnt As Integer
Dim BegPos As Integer, MatchIdx As Integer
Dim BegTime As Long
Dim SrchStr As String, Results As String, KeyCh As String

    lstMatches.Clear
    If MessMax = 0 Then Exit Sub
    
    SrchStr = NKEYBEG & UCase(txtSearch)
    If Len(SrchStr) = 1 Then
        ShowResult "Please enter a Completion Code, Reason Code or" & vbCrLf & "part of a Symbolic Name to search."
        Exit Sub
    End If
      
    Results = ""
    MatchCnt = 0
    If DebugFlag Then BegTime = GetTickCount()
    
    ' Search numeric keys
    PrevPos = 3
    Do
            ChPos = InStr(PrevPos, NumericKeys, SrchStr)
            If ChPos = 0 Then Exit Do
            MessIdx = (Asc(Mid(NumericKeys, ChPos - 2, 1)) - 33) * 90 + Asc(Mid(NumericKeys, ChPos - 1, 1)) - 33
            MatchCnt = MatchCnt + 1
            MatchIdxList(MatchCnt) = MessIdx
            PrevPos = ChPos + 2
    Loop
       
    If MatchCnt = 0 Then
        ' Search symbolic keys
        SrchStr = Mid(SrchStr, 2)
        PrevPos = 3
        Do
            ChPos = InStr(PrevPos, SymbolicKeys, SrchStr)
            If ChPos = 0 Then Exit Do
            BegPos = ChPos
            Do
                BegPos = BegPos - 1
                KeyCh = Mid(SymbolicKeys, BegPos, 1)
                If KeyCh = NKEYBEG Then
                    MessIdx = (Asc(Mid(SymbolicKeys, BegPos - 2, 1)) - 33) * 90 + Asc(Mid(SymbolicKeys, BegPos - 1, 1)) - 33
                    MatchCnt = MatchCnt + 1
                    MatchIdxList(MatchCnt) = MessIdx
                    Exit Do
                End If
            Loop Until KeyCh = NKEYEND
            Do Until Mid(SymbolicKeys, ChPos, 1) = NKEYEND
                ChPos = ChPos + 1
            Loop
            PrevPos = ChPos + 4
        Loop
    End If
        
    If MatchCnt = 0 Then
        lstMatches.AddItem "No match on '" & UCase(txtSearch) & "'."
        txtResult.Text = ""
    Else
        If MatchCnt = 1 Then
            lstMatches.AddItem " One match:"
        Else
            lstMatches.AddItem " " & MatchCnt & " partial matches:"
        End If
        ' Show summary for each partial match
        For MatchIdx = 1 To MatchCnt
            MessIdx = MatchIdxList(MatchIdx)
            If Mess(MessIdx).MType = MTYPENONE Then ParseMess MessIdx
            lstMatches.AddItem Mess(MessIdx).MValue & vbTab & "x" & Hex(Mess(MessIdx).MValue) & vbTab & Mess(MessIdx).MSymConst
            lstMatches.ItemData(lstMatches.NewIndex) = MessIdx
        Next MatchIdx
        lstMatches.ListIndex = 1    ' Force lstMatches_Click()
    End If
    
    If DebugFlag Then MsgBox "Debug: Search took " & GetTickCount() - BegTime & "ms" & vbCrLf & Results
    
End Sub

Public Sub PrinterInit()

    Printer.ScaleMode = vbMillimeters
    Printer.DrawWidth = 1
    Printer.DrawStyle = vbSolid
    Printer.ColorMode = vbPRCMMonochrome
    
    Printer.FontName = dlgFont.FontName
    Printer.FontSize = dlgFont.FontSize
    Printer.FontBold = False
    Printer.FontItalic = False

End Sub
