VERSION 5.00
Begin VB.Form frmMake 
   Appearance      =   0  'Flat
   Caption         =   "Make Binary Resource"
   ClientHeight    =   5070
   ClientLeft      =   1050
   ClientTop       =   1485
   ClientWidth     =   7380
   BeginProperty Font 
      Name            =   "MS Sans Serif"
      Size            =   8.25
      Charset         =   0
      Weight          =   700
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H80000008&
   Icon            =   "make5.frx":0000
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5070
   ScaleWidth      =   7380
   Begin VB.CommandButton cmdDump 
      Appearance      =   0  'Flat
      Caption         =   "&Dump"
      Height          =   315
      Left            =   1200
      TabIndex        =   5
      Top             =   780
      Width           =   795
   End
   Begin VB.TextBox txtLog 
      Appearance      =   0  'Flat
      BackColor       =   &H8000000F&
      BorderStyle     =   0  'None
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1275
      Left            =   60
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   6
      Text            =   "make5.frx":030A
      Top             =   1200
      Width           =   2775
   End
   Begin VB.CommandButton cmdMake 
      Appearance      =   0  'Flat
      Caption         =   "&Make"
      Default         =   -1  'True
      Height          =   315
      Left            =   60
      TabIndex        =   4
      Top             =   780
      Width           =   915
   End
   Begin VB.CommandButton cmdClose 
      Appearance      =   0  'Flat
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   315
      Left            =   2220
      TabIndex        =   3
      Top             =   780
      Width           =   915
   End
   Begin VB.TextBox txtDataFile 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   1920
      TabIndex        =   2
      Text            =   "txtDataFile"
      Top             =   420
      Width           =   1995
   End
   Begin VB.TextBox txtDataDir 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   315
      Left            =   1920
      TabIndex        =   1
      Text            =   "txtDataDir"
      Top             =   60
      Width           =   5355
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Data File"
      ForeColor       =   &H80000008&
      Height          =   195
      Index           =   1
      Left            =   60
      TabIndex        =   7
      Top             =   480
      Width           =   780
   End
   Begin VB.Label Label1 
      Appearance      =   0  'Flat
      AutoSize        =   -1  'True
      BackColor       =   &H80000005&
      BackStyle       =   0  'Transparent
      Caption         =   "Data Directory"
      ForeColor       =   &H80000008&
      Height          =   195
      Index           =   0
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   1245
   End
End
Attribute VB_Name = "frmMake"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'
' MQMCH "MQSeries Messages and Codes Helper" in Visual Basic 5.0
'
' make5.frm  "frmMake" Form and Code module
'
' Copyright IBM Global Services Australia 2001
'
' Version     Date          Name       Changes
'     2.1     01 Sep 1999   Glenn      Initial version, based on PCWIN31\MQMCH\MAKE5.FRM for VB 3.0
'                           Baddeley   <glenbadd@au1.ibm.com>
'     2.2     20 Aug 2001   GB         Support MQ 5.2 only and new data file format only
'     2.4     24 Aug 2001   GB         Use registry rather that ini
'     2.5.1   19 Oct 2001   GB          Cater for duplicate reason codes (eg. 2192)
'
Option Explicit

Private Sub cmdClose_Click()

    Hide

End Sub

Private Sub cmdDump_Click()

    DumpBinaryResource

End Sub

Private Sub cmdMake_Click()

    MakeBinaryResource

End Sub

Private Sub DumpBinaryResource()

Dim PrevPos As Integer, ChPos As Integer
Dim EolPrev As Integer, EolPos As Integer
Dim Msg As String, CcType As String
Dim IdList As String, RcDet As String, RcKey As String

    MousePointer = vbHourglass
    On Error GoTo DumpError
    Msg = "Binary Resource File: " & ResExeFile & vbCrLf

    BinResOpen ResExeFile, 0
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't open to read." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
    Else
        Msg = Msg & "BinResOpen OK, " & BR_IdxUsedEntsLen & " of " & BR_IdxMaxEntsLen & " bytes used in index (" & CSng(BR_IdxUsedEntsLen * 100! / BR_IdxMaxEntsLen) & "% full)" & vbCrLf
    
        GoSub DumpBinResDo

        BinResClose
        If BinResError Then
            Msg = Msg & BINRESERRPFX & "Can't close." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Else
            Msg = Msg & "BinResClose OK" & vbCrLf
        End If
    End If

DumpExit:
    
    MousePointer = vbDefault
    txtLog = Msg
    txtLog.SetFocus

Exit Sub

DumpError:

    Msg = Msg & "Error " & Err & ": " & Error

Resume DumpExit

DumpBinResDo:


    IdList = BinResGetIds()
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't get identifiers." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Return
    End If

    CcType = CStr(MTYPECC)

    PrevPos = 1
    Do
        ChPos = InStr(PrevPos, IdList, vbNullChar)
        If ChPos = 0 Then Exit Do
        RcKey = Mid(IdList, PrevPos, ChPos - PrevPos)
        RcDet = BinResGet(RcKey)
        If BinResError Then
            Msg = Msg & BINRESERRPFX & "Can't get string." & vbCrLf & "Key=" & RcKey & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
            Return
        End If
        If Left(RcDet, 1) = CcType Then
            EolPrev = 1
            Do
                EolPos = InStr(EolPrev, RcDet, EOLMARK)
                If EolPos = 0 Then Exit Do
                RcDet = Left(RcDet, EolPos - 1) & vbCrLf & Mid(RcDet, EolPos + 1)
                EolPrev = EolPos + 2
            Loop
            Msg = Msg & RcKey & "=" & RcDet & vbCrLf
        Else
            Msg = Msg & RcKey & "=" & Left(RcDet, 70) & vbCrLf
        End If
        PrevPos = ChPos + 1
    Loop
    
Return

End Sub

Private Sub Form_Activate()

    txtLog = "Ready."

End Sub

Private Sub Form_Load()

Dim hRegKey As Long
    
    ' Get users preferences from registry
    hRegKey = RegcOpenRead(HKCU, APPKEY)
    txtDataDir = RegcQueryValueString(hRegKey, "Make.DataDir", CurDir)
    txtDataFile = RegcQueryValueString(hRegKey, "Make.DataFile", "mqmchdata-text.o")
    RegcGetWindowSize hRegKey, "Make.Window", Me
    RegcClose hRegKey

    DidMake = True

End Sub

Private Sub Form_Resize()
    
    If Visible And WindowState <> vbMinimized Then
        txtLog.Width = ScaleWidth - txtLog.Left * 2
        txtLog.Height = ScaleHeight - txtLog.Top - txtDataDir.Top
    End If

End Sub

Private Sub Form_Unload(Cancel As Integer)

Dim hRegKey As Long
    
    ' Save users preferences in registry
    hRegKey = RegcOpenWrite(HKCU, APPKEY)
    RegcWriteValueString hRegKey, "Make.DataDir", txtDataDir
    RegcWriteValueString hRegKey, "Make.DataFile", txtDataFile
    RegcPutWindowSize hRegKey, "Make.Window", Me
    RegcClose hRegKey
    
End Sub

Private Sub MakeBinaryResource()

' Resource file contains keys:
' KeyCnt=n                      n = number of keys
' NumericKeys=xxxxx             Numeric values (decimal and hexidecimal) lookup string
' SymbolicKeys=xxxxx            Symbolic names lookup string
' 3.0=xxxxx                     Edition notice containing document and version details
' a=Type;NumericValue;SymbolicName;Text    Key a = 1 to n
'
' Format of lookup strings is many characters of:
' x y [ zzzz ]
'
' x y calculates the key index (a)
' zzzz is the lookup string
'

Dim Fid As Integer, InCnt As Integer, KeyCnt As Integer, ChPos As Integer

Dim CodeVal As Long

Dim Msg As String, DataFile As String, CodeData As String
Dim InRec As String, CodeDet As String, NumerKeys As String, SymboKeys As String
Dim IdxStr As String, CodeKey As String, CodeSym As String, CodeDesc As String

    On Error GoTo MakeError
    MousePointer = vbHourglass
    
    DataFile = txtDataDir & DIRSEP & txtDataFile
    Msg = "Making Binary Resource as at " & Format(Now, "HH:MM:SS dd mmmm yyyy") & vbCrLf
    GoSub MakeBinResDo

MakeExit:
    
    MousePointer = vbDefault
    txtLog = Msg

Exit Sub

MakeError:

    Msg = Msg & "Error " & Err & ": " & Error

Resume MakeExit

MakeBinResDo:

    Msg = Msg & "Binary Resource File: " & ResExeFile & vbCrLf

    BinResOpen ResExeFile, RESINDEXSIZE
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't open to append." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Return
    End If
    Msg = Msg & "BinResOpen OK" & vbCrLf

    KeyCnt = 0
    NumerKeys = ""
    SymboKeys = ""
    
    GoSub ProcessDataFile

    If BinResError = 0 Then
        CodeKey = "KeyCnt"
        BinResAppend CodeKey, CStr(KeyCnt)
        If BinResError Then Msg = Msg & BINRESERRPFX & "Can't append string." & vbCrLf & "Key=" & CodeKey & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Msg = Msg & CodeKey & "=" & KeyCnt & vbCrLf

        CodeKey = "NumericKeys"
        BinResAppend CodeKey, NumerKeys
        If BinResError Then Msg = Msg & BINRESERRPFX & "Can't append string." & vbCrLf & "Key=" & CodeKey & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Msg = Msg & CodeKey & "= (length " & Len(NumerKeys) & ")" & vbCrLf & NumerKeys & vbCrLf

        CodeKey = "SymbolicKeys"
        BinResAppend CodeKey, SymboKeys
        If BinResError Then Msg = Msg & BINRESERRPFX & "Can't append string." & vbCrLf & "Key=" & CodeKey & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Msg = Msg & CodeKey & "= (length " & Len(SymboKeys) & ")" & vbCrLf & SymboKeys & vbCrLf
    End If
    
    BinResClose
    If BinResError Then
        Msg = Msg & BINRESERRPFX & "Can't close." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
        Return
    End If
    Msg = Msg & "BinResClose OK" & vbCrLf

Return

ProcessDataFile:

    Msg = Msg & "Processing Data File: " & DataFile & vbCrLf
    txtLog = Msg
    txtLog.Refresh
    Fid = FreeFile
    Open DataFile For Input Access Read As #Fid
    InCnt = 0
    CodeDet = ""
    Do Until EOF(Fid) Or BinResError <> 0
        Line Input #Fid, InRec
        InCnt = InCnt + 1

        If Left(InRec, 1) = "[" Then
          If InStr(InRec, ",MQRC_") Then
            If Len(CodeDet) Then GoSub ProcessCode
            ' Reason code
            ChPos = InStr(InRec, ",")
            CodeVal = CLng(Mid(InRec, 2, ChPos - 2))
            CodeSym = Mid(InRec, ChPos + 1, Len(InRec) - ChPos - 1)
            CodeDet = MTYPERC
            CodeDesc = ""
            
          ElseIf InStr(InRec, ",MQCC_") Then
            If Len(CodeDet) Then GoSub ProcessCode
            ' Completion code
            ChPos = InStr(InRec, ",")
            CodeVal = CLng(Mid(InRec, 2, ChPos - 2))
            CodeSym = Mid(InRec, ChPos + 1, Len(InRec) - ChPos - 1)
            CodeDet = MTYPECC
            CodeDesc = ""
          
          ElseIf Left(InRec, 3) = "[DI" Then
            If Len(CodeDet) Then GoSub ProcessCode
            ' Data information
            ChPos = InStr(InRec, ",")
            CodeVal = CLng(Mid(InRec, 4, ChPos - 4))    ' Relates to DI_VERSION
            CodeSym = Mid(InRec, ChPos + 1, Len(InRec) - ChPos - 1)
            CodeDet = MTYPEDI
            CodeDesc = ""
          
          ElseIf InRec = "[end]" Then
            If Len(CodeDet) Then GoSub ProcessCode
          
          End If
            
        Else
          ' Assume anything else is a line of description
          CodeDesc = CodeDesc & EOLMARK & InRec
        
        End If

    Loop

    Close #Fid
    Msg = Msg & InCnt & " records, " & KeyCnt & " codes in data file." & vbCrLf

Return

ProcessCode:

    If CodeDet = MTYPEDI Then
        ' End of data information
        CodeKey = CodeDet & "." & CodeVal
        CodeData = Mid(CodeDesc, 2)
        BinResAppend CodeKey, CodeData
        If BinResError Then
            Msg = Msg & BINRESERRPFX & "Can't append string." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
            Msg = Msg & "Key=" & CodeKey & vbCrLf & "Data=" & CodeData & vbCrLf
            Return
        End If
    Else
        ' End of completion code or reason code
        KeyCnt = KeyCnt + 1
        CodeKey = CStr(KeyCnt)
        CodeData = CodeDet & FLDSEP & CodeVal & FLDSEP & CodeSym & FLDSEP & Mid(CodeDesc, 2)
        BinResAppend CodeKey, CodeData
        If BinResError Then
            Msg = Msg & BINRESERRPFX & "Can't append string." & vbCrLf & "Error=" & BinResError & " " & BinResStatus & vbCrLf
            Msg = Msg & "Key=" & CodeKey & vbCrLf & "Data=" & CodeData & vbCrLf
            Return
        End If
        IdxStr = Chr(KeyCnt \ 90 + 33) & Chr(KeyCnt Mod 90 + 33)
        If CodeVal > 9 Then
            NumerKeys = NumerKeys & IdxStr & NKEYBEG & CodeVal & NKEYEND & IdxStr & NKEYBEG & Hex(CodeVal) & NKEYEND
        Else
            NumerKeys = NumerKeys & IdxStr & NKEYBEG & CodeVal & NKEYEND
        End If
        SymboKeys = SymboKeys & IdxStr & NKEYBEG & CodeSym & NKEYEND
    End If
    DoEvents

Return

End Sub

